<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 33.40.1 - List of users</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>

  <div class="container">
    <div class="text-center my-4">
      <h2>Danh sách người dùng đăng ký</h2>
    </div>
    <div>
      <button id="btn-add-user" class="btn btn-success col-2 form-group">Add user</button>
    </div>
    <table id="table-user" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Id</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
      
      </tbody>
    </table>
  </div>
  
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    
    //load the page
    $(document).ready(function(){onPageLoading()})
      
    //add click event for "Add user" button
    $("#btn-add-user").on("click", btnAddUserClick)

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    
    //function for loading the web page
    function onPageLoading(){
      callApiGetUserData();
    };

    //call API for load users' data
    function callApiGetUserData(){
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
        type: "GET",
        success: function(result){
          console.log(result);
          loadUserDataToTable(result);
        },
        error: function(ajaxContext){
          console.log(ajaxContext.status)
        }
      });
    }

    //load data to the table
    function loadUserDataToTable(paramUser){
      
      //create a table
      var vTable = $("#table-user");
      
      for (var bI=0; bI < paramUser.length; bI++){
        //create a row in the table and add to the table
        var vNewRow = $("<tr>").appendTo(vTable);
        //create new cells and load the data to them  
        $("<td>", {html: paramUser[bI].id}).appendTo(vNewRow);
        $("<td>", {html: paramUser[bI].firstname}).appendTo(vNewRow);
        $("<td>", {html: paramUser[bI].lastname}).appendTo(vNewRow);
        $("<td>", {html: paramUser[bI].country}).appendTo(vNewRow);  
        $("<td>", {html: paramUser[bI].subject}).appendTo(vNewRow);
        $("<td>", {html: paramUser[bI].customerType}).appendTo(vNewRow);
        $("<td>", {html: paramUser[bI].registerStatus}).appendTo(vNewRow);

        //create a column for action buttons
        var vAction = $("<td>").appendTo(vNewRow); 
        
        //create edit button
        var vEditButton = $("<button>")
          .html("Edit")
          .attr('class', "btn btn-primary col-6 btn-edit");
        vEditButton.appendTo(vAction);
        //add data to Edit
        vEditButton.attr("data-id", paramUser[bI].id);
        vEditButton.attr("data-firstname", paramUser[bI].firstname);
        vEditButton.attr("data-lastname", paramUser[bI].lastname);
        vEditButton.attr("data-country", paramUser[bI].country);
        vEditButton.attr("data-subject", paramUser[bI].subject);
        vEditButton.attr("data-customertype", paramUser[bI].customerType);
        vEditButton.attr("data-registerstatus", paramUser[bI].registerStatus);

        //create Delete Button
        var vDeleteButton = $("<button>")
          .html("Delete")
          .attr("class", "btn btn-warning col-6 btn-delete")
        vDeleteButton.appendTo(vAction);
        //add data to Delete Button
        vDeleteButton.data("id", paramUser[bI].id)
        vDeleteButton.data("firstname", paramUser[bI].firstname)
        vDeleteButton.data("lastname", paramUser[bI].lastname)
        vDeleteButton.data("country", paramUser[bI].country)
        vDeleteButton.data("subject", paramUser[bI].subject)
        vDeleteButton.data("customertype", paramUser[bI].customerType)
        vDeleteButton.data("registerstatus", paramUser[bI].registerStatus)
                           
      }
    }

    //add event handler for Edit Button
    $("#table-user").on('click', ".btn-edit", onEditButtonClick);

    //add event handler for Delete Button
    $("#table-user").on('click', ".btn-delete", onDeleteButtonClick);

    //function for Edit Button
    function onEditButtonClick(){
      console.log("%c Edit Button was clicked - The edited ID: ", "color:orange", $(this).data("id"))
      
      var vId = $(this).data("id");
      //add query string
      const vUSER_DETAIL = "file:///C:/Users/hphat/Desktop/J2232/2023-02-24/Task%2033.40/Task%2033.40.2%20-%20User%20detail.html"
      var vUrlSiteToOpen = vUSER_DETAIL + "?" + 
      "id=" + vId;
      window.location.href = vUrlSiteToOpen;
    }

    //function for Delete Button
    function onDeleteButtonClick(){
      
    
      let text = "Do you want to delete this user?\nClick OK to confirm the delete or Cancel.";
      if (confirm(text) == true){
        
        callApideleteUser($(this).data("id"));
        console.log("%c Delete Button was clicked - The deleted ID: ", "color:orange",  $(this).data("id"));
      
      } else 
      {
        alert("You just canceled the delete !!!");
      }
    }

    //function for Add User Button
    function btnAddUserClick(){
      
      window.location.href = "file:///C:/Users/hphat/Desktop/J2232/2023-02-24/Task%2033.40/Task%2033.40.3%20-%20Insert%20new%20user.html"

    }

    //funtion for deleting the user
    function callApideleteUser(paramData){

      $.ajax ({
        url: gBASE_URL + paramData,
        type: "DELETE",
        success: function(result){
                  alert("The user of ID " + paramData + " has been deleted !!!");
        },
        error: function(ajaxContext){
                console.log(ajaxContext)
        }
      })
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    
   
</script>
</body>

</html>
​